Index: /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js
===================================================================
--- /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js	(revision 6845)
+++ /SMC/trunk/SMC/src/web/scripts/js/smc-graph.js	(revision 6846)
@@ -182,436 +199,515 @@
 
 /** generate a grouped (by type) list of nodes
-    @param nodes - accepts an array of nodes (like in data.nodes)
-*/  
-function renderNodeList (nodes, target_container_selector) {
+ @param nodes - accepts an array of nodes (like in data.nodes)
+ */
+function renderNodeList(nodes, target_container_selector) {
 
     nest = d3.nest()
-    .key(function(d) { return d.type; })
-    .sortValues(function(a, b) { return d3.ascending(a.name, b.name); })
-    .entries(nodes);
-  
+            .key(function (d) {
+                return d.type;
+            })
+            .sortValues(function (a, b) {
+                return d3.ascending(a.name, b.name);
+            })
+            .entries(nodes);
+
     target_container = d3.select(target_container_selector);
-        target_container.selectAll("div.node-detail").remove();
-        
-        var group_divs = target_container.selectAll("div.node-detail").data(nest)
-                        .enter().append("div")
-                       .attr("id", function (d) { return "detail-" + d.key })                        
-                        .classed("node-detail cmds-ui-block init-show", 1)
-                        // collapse groups in index, but expand right away in detail view
-                        //.classed("init-show", (target_container_selector != index_container_selector)); 
-                        
-      var group_headers = group_divs.append("div").classed("header", 1)
-                        .text(function (d) { return d.key + " |" + d.values.length + "|"});
-                        
-      var list =  group_divs.append("div").classed("content",1)
-                    .append("ul");
-      var item_li = list.selectAll(".node-item")        
-                    .data(function(d) { return d.values; })
-                    .enter().append("li")
-                    .attr("class", "node-item");
-               item_li.append("span")
-/*                     .text(function (d) { return d.name})*/
-                    .text(renderItemText)
-                    .on("click", function(d) { d.selected= d.selected ? 0 : 1 ; updateSelected() });
-          
-                    
-            /* slightly different behaviour for the main-index and rendering of the selected nodes in the detail-view */
-          //  console.log("target_container:" + target_container_selector);
-            if (target_container_selector == index_container_selector) {
-                index_container = target_container;
-                item_li.attr("id", function (d) { return "n-" + d.name })
-                        .attr("title", function(d) { return  d.id });
-                item_li.classed("highlight", function (d) { return d.selected });
-/*                item_li.classed("highlight", liveSelected);*/
-                
-                
-              } else {
-                 var item_detail = item_li.append("div");
-                                        /*  .classed("node-detail", 1);*/
-                            
-                 item_detail.append("a")
-                            .attr("href",function (d) { if (d.type.toLowerCase()=='datcat') return d.id
-                                                        else if (d.type.toLowerCase()=='philosopher') return wiki_url + d.id;  
-                                                        else return comp_reg_url + d.id })
-                            .text(function (d) { return d.id });
-                
-                profile_item_detail = item_detail.filter(function(d, i) { return d.type.toLowerCase()=='profile' }); 
-                profile_item_detail.append("a")
-                            .attr("target",'_blank')
-                            .attr("href",function (d) { return 'profiles/' + d.key + '.html' })
-                            .text(' html-view ');
-                
-/*                profile_item_detail.append("a")*/
-/*                item_detail.append("a")
-                            .classed("scan", function (d) {  return !(d.type=='Profile') } )
-                            .attr("target",'_blank')
-                            .attr("href",function (d) { if (d.type=='Profile') { return mdrepo_url_search +  'cmd.profile=%22' + d.id + '%22'; }
-                                                          else { return mdrepo_url_scan +  'cmd:' +  d.name; }   }  )
-                            .text(' mdrepo-view ');*/
-                
-                 item_detail_detail = item_detail.append("div").html(
-                                 function (d) { 
-                                    var detail_info_div = getDetailInfo(d.type.toLowerCase(), d.key, this);
-                                    if (detail_info_div) {
-                                        return detail_info_div 
-                                    } else { 
-                                        return  "<div>No detail</div>"; 
-                                    }
-                          });
-                          
-                 item_detail_detail.classed("node-detail", 1);
-                           
-              }
-                        
-   handleUIBlock($(target_container_selector).find(".node-detail.cmds-ui-block"));
-  
-}
-
-function renderItemText(d) { 
+    target_container.selectAll("div.node-detail").remove();
+
+    var group_divs = target_container.selectAll("div.node-detail").data(nest)
+            .enter().append("div")
+            .attr("id", function (d) {
+                return "detail-" + d.key
+            })
+            .classed("node-detail cmds-ui-block init-show", 1)
+    // collapse groups in index, but expand right away in detail view
+    //.classed("init-show", (target_container_selector != index_container_selector)); 
+
+    var group_headers = group_divs.append("div").classed("header", 1)
+            .text(function (d) {
+                return d.key + " |" + d.values.length + "|"
+            });
+
+    var list = group_divs.append("div").classed("content", 1)
+            .append("ul");
+    var item_li = list.selectAll(".node-item")
+            .data(function (d) {
+                return d.values;
+            })
+            .enter().append("li")
+            .attr("class", "node-item");
+    item_li.append("span")
+            /*                     .text(function (d) { return d.name})*/
+            .text(renderItemText)
+            .on("click", function (d) {
+                d.selected = d.selected ? 0 : 1;
+                updateSelected()
+            });
+
+
+    /* slightly different behaviour for the main-index and rendering of the selected nodes in the detail-view */
+    //  console.log("target_container:" + target_container_selector);
+    if (target_container_selector == index_container_selector) {
+        index_container = target_container;
+        item_li.attr("id", function (d) {
+            return "n-" + d.name
+        })
+                .attr("title", function (d) {
+                    return  d.id
+                });
+        item_li.classed("highlight", function (d) {
+            return d.selected
+        });
+        /*                item_li.classed("highlight", liveSelected);*/
+
+
+    } else {
+        var item_detail = item_li.append("div");
+        /*  .classed("node-detail", 1);*/
+
+        item_detail.append("a")
+                .attr("href", function (d) {
+                    if (d.type.toLowerCase() == 'datcat')
+                        return d.id
+                    else if (d.type.toLowerCase() == 'philosopher')
+                        return wiki_url + d.id;
+                    else
+                        return comp_reg_url + d.id
+                })
+                .text(function (d) {
+                    return d.id
+                });
+
+        profile_item_detail = item_detail.filter(function (d, i) {
+            return d.type.toLowerCase() == 'profile'
+        });
+        profile_item_detail.append("a")
+                .attr("target", '_blank')
+                .attr("href", function (d) {
+                    return 'profiles/' + d.key + '.html'
+                })
+                .text(' html-view ');
+
+        /*                profile_item_detail.append("a")*/
+        /*                item_detail.append("a")
+         .classed("scan", function (d) {  return !(d.type=='Profile') } )
+         .attr("target",'_blank')
+         .attr("href",function (d) { if (d.type=='Profile') { return mdrepo_url_search +  'cmd.profile=%22' + d.id + '%22'; }
+         else { return mdrepo_url_scan +  'cmd:' +  d.name; }   }  )
+         .text(' mdrepo-view ');*/
+
+        item_detail_detail = item_detail.append("div").html(
+                function (d) {
+                    var detail_info_div = getDetailInfo(d.type.toLowerCase(), d.key, this);
+                    if (detail_info_div) {
+                        return detail_info_div
+                    } else {
+                        return  "<div>No detail</div>";
+                    }
+                });
+
+        item_detail_detail.classed("node-detail", 1);
+
+    }
+
+    handleUIBlock($(target_container_selector).find(".node-detail.cmds-ui-block"));
+
+}
+
+function renderItemText(d) {
     if (show_count) {
-        return d.name + ' |' + d.count + '|'; 
-      }
-    else {
+        return d.name + ' |' + d.count + '|';
+    } else {
         return d.name;
-        }
- }
-
-function filterIndex (search_string){
-    var filtered_index_nodes = data_all.nodes.filter(function(d, i) { 
-     //   console.log(d.name.indexOf(search_string));
-        return d.name.toLowerCase().indexOf(search_string.toLowerCase()) > -1; 
+    }
+}
+
+function filterIndex(search_string) {
+    var filtered_index_nodes = data_all.nodes.filter(function (d, i) {
+        //   console.log(d.name.indexOf(search_string));
+        return d.name.toLowerCase().indexOf(search_string.toLowerCase()) > -1;
     });
-    
-   renderIndex(filtered_index_nodes, index_container_selector);
+
+    renderIndex(filtered_index_nodes, index_container_selector);
 }
 
 
 /** render data (data_show) as graph  into target-container (graph_container) */
-function renderGraph (data, target_container) {
+function renderGraph(data, target_container) {
 // setting defaults 
 // for now, ignore the params, as they are always the same
-    
+
     //data = typeof data !== 'undefined' ? data : dataToShow(nodes_sel);
-    
-    if ($(this).is('#input-graph')) {        
-        console.log("graph-source changed! reinitializing graph");
-        initGraph(data);
-    }
-    
+
+    try {
+        if ($(this).is('#input-graph')) {
+            console.log("graph-source changed! reinitializing graph");
+            initGraph(data);
+        }
+    } catch (e) {
+    }
+
     data = dataToShow(nodes_sel);
-  
-      target_container = graph_container ;
-    
-    if (data == null) { 
-       $(target_container).text("no data to show"); 
-       return;
-     } else {
-       $(target_container).text("");
-     }
-  
-  // compute the maximum number, but only if it will be needed (i.e. node-size=count)
-    if (opt("node-size")=="count") {
+
+    target_container = graph_container;
+
+    if (data == null) {
+        $(target_container).text("no data to show");
+        return;
+    } else {
+        $(target_container).text("");
+    }
+
+    // compute the maximum number, but only if it will be needed (i.e. node-size=count)
+    if (opt("node-size") == "count") {
         var init_count = [];
-            data.nodes.forEach(function(d,i){init_count.push(+d.count);})
-            data.count_max = d3.max(init_count);
-            data.node_size_ratio = Math.sqrt(data.count_max) / max_circle;
-        }
-
-  // information about the displayed data 
-        notifyUser("show nodes: " + data_show.nodes.length + "; "
-                        + "show links: " + data_show.links.length + "; " 
-                        + "max count:" + data.count_max + "; " 
-                        + "node_size_ration:" + data.node_size_ratio);
-        
-  
-  
-  
-   var w = $(target_container).width(),
-        h = $(target_container).height(); 
-     
-     var ratio = w / (data_all.init_x_max - data_all.init_x_min); 
+        data.nodes.forEach(function (d, i) {
+            init_count.push(+d.count);
+        })
+        data.count_max = d3.max(init_count);
+        data.node_size_ratio = Math.sqrt(data.count_max) / max_circle;
+    }
+
+    // information about the displayed data 
+    notifyUser("show nodes: " + data_show.nodes.length + "; "
+            + "show links: " + data_show.links.length + "; "
+            + "max count:" + data.count_max + "; "
+            + "node_size_ration:" + data.node_size_ratio);
+
+
+
+
+    var w = $(target_container).width(),
+            h = $(target_container).height();
+
+    var ratio = w / (data_all.init_x_max - data_all.init_x_min);
     var node_size_int = parseInt(opt("node-size"));
-    var font_size_int = base_font_size + (node_size_int / 2);  
- var link_distance = parseInt(opt("link-distance"))
- 
-        // console.log (w + '-' + h);
-     var force = d3.layout.force()
+    var font_size_int = base_font_size + (node_size_int / 2);
+    var link_distance = parseInt(opt("link-distance"))
+
+    // console.log (w + '-' + h);
+    var force = d3.layout.force()
             .nodes(data.nodes)
             .links(data.links)
             .size([w, h])
 
-            .friction(parseInt(opt("friction")) / 100 )
-            
-            .gravity(parseInt(opt("gravity")) / 100 )
-            
+            .friction(parseInt(opt("friction")) / 100)
+
+            .gravity(parseInt(opt("gravity")) / 100)
+
             .linkDistance(parseInt(opt("link-distance")))
-            
-/*            .linkDistance(function(d){return link_distance / (d.weight * d.value) })*/
-            /* Profiles:           
-            .linkStrength(function(d){return d.value})
-                        
-            */
-            //.charge(parseInt(opt("charge")) * -1)
-          
-          if (parseInt(opt("charge"))==0) {
-            force.charge(0);
-          } else {
-            force.charge(function(d) { if (opt("node-size")=="count")
-                            {var node_charge = (Math.sqrt(d.count)<=min_circle) ?  min_circle  : Math.sqrt(d.count) / data.node_size_ratio;
-                            //console.log (node_charge + ':' + d.count);
-                            return node_charge * -1 * parseInt(opt("charge"));
-                                }
-                              //{ return -d.count * parseInt(opt("charge"));  }
-                            else { return parseInt(opt("charge")) * -1} })
-          }
-         
-         force.on("tick", tick)
+
+    /*            .linkDistance(function(d){return link_distance / (d.weight * d.value) })*/
+    /* Profiles:           
+     .linkStrength(function(d){return d.value})
+     
+     */
+    //.charge(parseInt(opt("charge")) * -1)
+
+    if (parseInt(opt("charge")) == 0) {
+        force.charge(0);
+    } else {
+        force.charge(function (d) {
+            if (opt("node-size") == "count")
+            {
+                var node_charge = (Math.sqrt(d.count) <= min_circle) ? min_circle : Math.sqrt(d.count) / data.node_size_ratio;
+                //console.log (node_charge + ':' + d.count);
+                return node_charge * -1 * parseInt(opt("charge"));
+            }
+            //{ return -d.count * parseInt(opt("charge"));  }
+            else {
+                return parseInt(opt("charge")) * -1
+            }
+        })
+    }
+
+    force.on("tick", tick)
             .start();
-        
-        if (opt("layout")=='freeze') {
-               data.nodes.forEach(function(d) { d.fixed=true });     
-        } else {
-                 data.nodes.forEach(function(d) { d.fixed=false});
-        }
-               
-            
+
+    if (opt("layout") == 'freeze') {
+        data.nodes.forEach(function (d) {
+            d.fixed = true
+        });
+    } else {
+        data.nodes.forEach(function (d) {
+            d.fixed = false
+        });
+    }
+
+
 //    console.log ("gravity: " + force.gravity() );              
-  
-       // remove old render:
-          d3.select(graph_container_selector).selectAll("svg").remove();
-                 
-        svg = d3.select(graph_container_selector).append("svg:svg")
-            .attr("width", w)        .attr("height", h);
-        
-        // Per-type markers, as they don't inherit styles.
-        
-      if (opt("curve").indexOf("arrow") > -1)  {
+
+    // remove old render:
+    d3.select(graph_container_selector).selectAll("svg").remove();
+
+    svg = d3.select(graph_container_selector).append("svg:svg")
+            .attr("width", w).attr("height", h);
+
+    // Per-type markers, as they don't inherit styles.
+
+    if (opt("curve").indexOf("arrow") > -1) {
         svg.append("svg:defs").selectAll("marker")
-          .data(["uses"])
-          .enter().append("svg:marker")
-            .attr("id", String)
-            .attr("markerUnits", "userSpaceOnUse")
-            .attr("viewBox", "0 -5 10 10")
-            .attr("refX", 10)
-            /*.attr("refY", -1.5)*/
-            .attr("markerWidth", 10)
-            .attr("markerHeight", 10)
-            .attr("orient", "auto")
-          .append("svg:path")
-            .attr("d", "M0,-3L10,0L0,3");
-       }
-        
-        var path = svg.append("svg:g").selectAll("path")
+                .data(["uses"])
+                .enter().append("svg:marker")
+                .attr("id", String)
+                .attr("markerUnits", "userSpaceOnUse")
+                .attr("viewBox", "0 -5 10 10")
+                .attr("refX", 10)
+                /*.attr("refY", -1.5)*/
+                .attr("markerWidth", 10)
+                .attr("markerHeight", 10)
+                .attr("orient", "auto")
+                .append("svg:path")
+                .attr("d", "M0,-3L10,0L0,3");
+    }
+
+    var path = svg.append("svg:g").selectAll("path")
             .data(force.links())
             .enter().append("svg:path")
-/*            .attr("class", function(d) { return "link uses"; })*/
+            /*            .attr("class", function(d) { return "link uses"; })*/
             .classed("link", 1)
             .classed("uses", 1)
-            .classed("highlight", function(d) { d.highlight } )
-            .attr("marker-end", function(d) { return "url(#uses)"; });
-            
-            if (opt("link-width")=="value") {
-                path.style("stroke-width", function(d) { return Math.sqrt(d.value); });
-/*             .style("stroke-width", function(d) { return d.value });*/
-            } 
-
-           path.append("title").text(function(d){ return d.value });
-            
-         var gnodes = svg.append("svg:g")
-                      .selectAll("g.node")
-                      .data(force.nodes())
-                      .enter().append("g")
-                      .attr("class", function(d) { return "node type-" + d.type.toLowerCase()})
-                      .classed("selected", function(d) { return d.selected; })
-                      .call(force.drag);
-                      
-          // dragging of all selected nodes on freeze layout
-          // this does not work yet
-          /*if (opt("layout")=="freeze") {
-                      gnodes.on("mousedown", function() {
-                            var m0 = d3.mouse(this);
-                
-                       gnodes.on("mousemove", function() {
-                            var m1 = d3.mouse(this),
-                        x0 = Math.min(w, m0[0], m1[0]),
-                        y0 = Math.min(w, m0[1], m1[1]),
-                        x1 = Math.max(0, m0[0], m1[0]),
-                        y1 = Math.max(0, m0[1], m1[1]);
-                        // console.log("DEBUG: mousedown: " + (x1-x0) + ( y1-y0));
-                            x_d = (x1 - x0);
-                            y_d = (y1 - y0);
-                               // y_d = d.y - d.py;
-                               // x_d = d.x - d.px;
-                        
-                            nodes_sel.forEach(function (d) {
-                                d.x += x_d;
-                                d.y += y_d;
-                            });
-                            
-                  });
-                
-                    gnodes.on("mouseup", function() {
-                        gnodes.on("mousemove", null).on("mouseup", null);
-                  });
-                
-                  d3.event.preventDefault();
-                });     
-            }          
-          */  
-            gnodes.append("svg:circle")
-/*            .attr("r", 6)*/
-                    .on("click", function(d) {d.selected= d.selected ? 0 : 1; 
-                                                console.log("click:" + d.key); 
-                                                updateSelected(); })
-                      .on("mouseover", highlight()).on("mouseout", unhighlight())
-            .attr("r", function(d) { if (opt("node-size")=="count") 
-                                        {return (Math.sqrt(d.count)<=min_circle) ?  min_circle  : Math.sqrt(d.count) / data.node_size_ratio;                                        
-                                        }
-                                        else { return node_size_int; }
-                                    })    
-            
-            gnodes.append("title")
-/*                .text(function (d) { return d.name + ' |' + d.count + '|' })*/                   
-                  .text(renderItemText);
-                  
-                  
-      
-         
-        /*
-       svg.selectAll("circle")
-            .attr("class", function(d) { return "type-" + d.type.toLowerCase()})
-            .classed("selected", function(d) { return d.selected; })
-          .on("click", function(d) {d.selected= d.selected ? 0 : 1; updateSelected() })
-          .on("mouseover", highlight("in")).on("mouseout", highlight("out"));
-        */
-        
-        // A copy of the text with a thick white stroke for legibility.
-        //if (opt("labels") =='show') {
-           gnodes.append("svg:text")
-                 .attr("x", 8)
-                 .attr("y", ".31em")
-                 .style("font-size", function(d) {
-                                    var fontsize = '';
-                                if (opt("node-size")=="count") 
-                                        {  fontsize = (Math.sqrt(d.count)<=min_circle) ?  base_font_size : Math.sqrt(d.count) / data.node_size_ratio;                                        
-                                        }
-                                        else { fontsize = font_size_int; }
-                                        return fontsize + 'px';
-                                        })
-                 .attr("class", "shadow")
-                 .classed("hide", opt("labels")=='hide')
-                 .text(function(d) { return d.name; });
-           gnodes.append("svg:text")
-                 .attr("x", 8)
-                 .attr("y", ".31em")
-                 .style("font-size", function(d) {
-                                    var fontsize = '';
-                                if (opt("node-size")=="count") 
-                                        {  fontsize = (Math.sqrt(d.count)<=min_circle) ?  base_font_size  : Math.sqrt(d.count) / data.node_size_ratio;                                        
-                                        }
-                                        else { fontsize = font_size_int; }
-                                        return fontsize + 'px';
-                                        })
-                 .classed("hide", function(d) { return !d.selected && opt("labels")=='hide'})
-                 .text(function(d) { return d.name; });
-        //}
-        
-  
-  var tick_counter=0;
-   function tick(e) {
-    var link_distance_int = parseInt(opt("link-distance"));      
-    var k =  10 * e.alpha;
-          if (opt("layout")=='dot') {
+            .classed("highlight", function (d) {
+                d.highlight
+            })
+            .attr("marker-end", function (d) {
+                return "url(#uses)";
+            });
+
+    if (opt("link-width") == "value") {
+        path.style("stroke-width", function (d) {
+            return Math.sqrt(d.value);
+        });
+        /*             .style("stroke-width", function(d) { return d.value });*/
+    }
+
+    path.append("title").text(function (d) {
+        return d.value
+    });
+
+    var gnodes = svg.append("svg:g")
+            .selectAll("g.node")
+            .data(force.nodes())
+            .enter().append("g")
+            .attr("class", function (d) {
+                return "node type-" + d.type.toLowerCase()
+            })
+            .classed("selected", function (d) {
+                return d.selected;
+            })
+            .call(force.drag);
+
+    // dragging of all selected nodes on freeze layout
+    // this does not work yet
+    /*if (opt("layout")=="freeze") {
+     gnodes.on("mousedown", function() {
+     var m0 = d3.mouse(this);
+     
+     gnodes.on("mousemove", function() {
+     var m1 = d3.mouse(this),
+     x0 = Math.min(w, m0[0], m1[0]),
+     y0 = Math.min(w, m0[1], m1[1]),
+     x1 = Math.max(0, m0[0], m1[0]),
+     y1 = Math.max(0, m0[1], m1[1]);
+     // console.log("DEBUG: mousedown: " + (x1-x0) + ( y1-y0));
+     x_d = (x1 - x0);
+     y_d = (y1 - y0);
+     // y_d = d.y - d.py;
+     // x_d = d.x - d.px;
+     
+     nodes_sel.forEach(function (d) {
+     d.x += x_d;
+     d.y += y_d;
+     });
+     
+     });
+     
+     gnodes.on("mouseup", function() {
+     gnodes.on("mousemove", null).on("mouseup", null);
+     });
+     
+     d3.event.preventDefault();
+     });     
+     }          
+     */
+    gnodes.append("svg:circle")
+            /*            .attr("r", 6)*/
+            .on("click", function (d) {
+                d.selected = d.selected ? 0 : 1;
+                console.log("click:" + d.key);
+                updateSelected();
+            })
+            .on("mouseover", highlight()).on("mouseout", unhighlight())
+            .attr("r", function (d) {
+                if (opt("node-size") == "count")
+                {
+                    return (Math.sqrt(d.count) <= min_circle) ? min_circle : Math.sqrt(d.count) / data.node_size_ratio;
+                } else {
+                    return node_size_int;
+                }
+            })
+
+    gnodes.append("title")
+            /*                .text(function (d) { return d.name + ' |' + d.count + '|' })*/
+            .text(renderItemText);
+
+
+
+
+    /*
+     svg.selectAll("circle")
+     .attr("class", function(d) { return "type-" + d.type.toLowerCase()})
+     .classed("selected", function(d) { return d.selected; })
+     .on("click", function(d) {d.selected= d.selected ? 0 : 1; updateSelected() })
+     .on("mouseover", highlight("in")).on("mouseout", highlight("out"));
+     */
+
+    // A copy of the text with a thick white stroke for legibility.
+    //if (opt("labels") =='show') {
+    gnodes.append("svg:text")
+            .attr("x", 8)
+            .attr("y", ".31em")
+            .style("font-size", function (d) {
+                var fontsize = '';
+                if (opt("node-size") == "count")
+                {
+                    fontsize = (Math.sqrt(d.count) <= min_circle) ? base_font_size : Math.sqrt(d.count) / data.node_size_ratio;
+                } else {
+                    fontsize = font_size_int;
+                }
+                return fontsize + 'px';
+            })
+            .attr("class", "shadow")
+            .classed("hide", opt("labels") == 'hide')
+            .text(function (d) {
+                return d.name;
+            });
+    gnodes.append("svg:text")
+            .attr("x", 8)
+            .attr("y", ".31em")
+            .style("font-size", function (d) {
+                var fontsize = '';
+                if (opt("node-size") == "count")
+                {
+                    fontsize = (Math.sqrt(d.count) <= min_circle) ? base_font_size : Math.sqrt(d.count) / data.node_size_ratio;
+                } else {
+                    fontsize = font_size_int;
+                }
+                return fontsize + 'px';
+            })
+            .classed("hide", function (d) {
+                return !d.selected && opt("labels") == 'hide'
+            })
+            .text(function (d) {
+                return d.name;
+            });
+    //}
+
+
+    var tick_counter = 0;
+    function tick(e) {
+        var link_distance_int = parseInt(opt("link-distance"));
+        var k = 10 * e.alpha;
+        if (opt("layout") == 'dot') {
             var offset = data_all.init_x_min;
             /*data.links.forEach(function(d, i) {
-              d.source.x = (d.source.init_x / 150 * link_distance_int) ;
-              d.target.x = (d.target.init_x / 150 * link_distance_int);
-            
-            });*/
-            
-            data.nodes.forEach (function(d,i) {
-                d.x = d.init_x * ratio - link_distance_int;  
+             d.source.x = (d.source.init_x / 150 * link_distance_int) ;
+             d.target.x = (d.target.init_x / 150 * link_distance_int);
+             
+             });*/
+
+            data.nodes.forEach(function (d, i) {
+                d.x = d.init_x * ratio - link_distance_int;
             });
-            
-          } else if (opt("layout")=='weak-tree') {
-              data.links.forEach(function(d, i) {
-              d.source.x -= k;
+
+        } else if (opt("layout") == 'weak-tree') {
+            data.links.forEach(function (d, i) {
+                d.source.x -= k;
                 d.target.x += k;
-                });
-          } else if (opt("layout")=='vertical-tree') {
-                   var ky= 1.4 * e.alpha, kx = .4 * e.alpha;
-                   data.links.forEach(function(d, i) {
-                     if (d.source.level==data_all.level_min) { d.source.y = first_level_margin };
-                   //  d.target.x += (d.source.x - d.target.x)  * kx;
-                     d.target.y += (d.source.y - d.target.y + link_distance_int) * ky;
-                    });
-           } else if (opt("layout")=='horizontal-tree') {
-                   var kx= 1.4 * e.alpha, ky = .4 * e.alpha;
-                   data.links.forEach(function(d, i) {
-                       //if (d.source.level==data_all.level_min) { d.source.x = first_level_margin };
-                       if (data_show.roots.indexOf(d.source.key) > -1 ) { d.source.x = first_level_margin };
-                       //d.target.y += (d.source.y - d.target.y)  * ky;
-                       d.target.x += (d.source.x - d.target.x + link_distance_int  ) * kx;
-                       //d.target.x += (d.source.x - d.target.x ) * kx;
-                  });
-           }
-           /*  parent foci 
-                  var kx = 1.2 * e.alpha;
-    data.links.forEach(function(d, i) {
-      d.target.x += (d.target.level * link_distance  - d.target.x) * kx;
-      });*/
-      
-      tick_counter ++;   
-       if (tick_counter % 2 == 0) {transform(); }
-   } // end  tick()
-
-
-    function transform () { 
-         
-       path.attr("d", function(d) {
-             // links as elliptical arc path segments
+            });
+        } else if (opt("layout") == 'vertical-tree') {
+            var ky = 1.4 * e.alpha, kx = .4 * e.alpha;
+            data.links.forEach(function (d, i) {
+                if (d.source.level == data_all.level_min) {
+                    d.source.y = first_level_margin
+                }
+                ;
+                //  d.target.x += (d.source.x - d.target.x)  * kx;
+                d.target.y += (d.source.y - d.target.y + link_distance_int) * ky;
+            });
+        } else if (opt("layout") == 'horizontal-tree') {
+            var kx = 1.4 * e.alpha, ky = .4 * e.alpha;
+            data.links.forEach(function (d, i) {
+                //if (d.source.level==data_all.level_min) { d.source.x = first_level_margin };
+                if (data_show.roots.indexOf(d.source.key) > -1) {
+                    d.source.x = first_level_margin
+                }
+                ;
+                //d.target.y += (d.source.y - d.target.y)  * ky;
+                d.target.x += (d.source.x - d.target.x + link_distance_int) * kx;
+                //d.target.x += (d.source.x - d.target.x ) * kx;
+            });
+        }
+        /*  parent foci 
+         var kx = 1.2 * e.alpha;
+         data.links.forEach(function(d, i) {
+         d.target.x += (d.target.level * link_distance  - d.target.x) * kx;
+         });*/
+
+        tick_counter++;
+        if (tick_counter % 2 == 0) {
+            transform();
+        }
+    } // end  tick()
+
+
+    function transform() {
+
+        path.attr("d", function (d) {
+            // links as elliptical arc path segments
             if (opt("curve").indexOf("arc") > -1)
-            {   var dx = d.target.x - d.source.x,
-                    dy = d.target.y - d.source.y,
-                    dr = Math.sqrt(dx * dx + dy * dy);
+            {
+                var dx = d.target.x - d.source.x,
+                        dy = d.target.y - d.source.y,
+                        dr = Math.sqrt(dx * dx + dy * dy);
                 return "M" + d.source.x + "," + d.source.y + "A" + dr + "," + dr + " 0 0,1 " + d.target.x + "," + d.target.y;
-            } else { 
-            // or straight
+            } else {
+                // or straight
                 return "M" + d.source.x + "," + d.source.y + "L" + d.target.x + "," + d.target.y;
-            }  
-       });
-         
-         /*circle.attr("cx", function(d) {return d.x;})
-                .attr("cy", function(d) {return d.y;});*/
-       gnodes.attr("transform", function(d) {
+            }
+        });
+
+        /*circle.attr("cx", function(d) {return d.x;})
+         .attr("cy", function(d) {return d.y;});*/
+        gnodes.attr("transform", function (d) {
             return "translate(" + d.x + "," + d.y + ")";
-       });
-        
-  /*     textgroup.attr("transform", function(d) {
-            return "translate(" + d.x + "," + d.y + ")";
-       });*/
-    }
-        
-        // Highlight selected nodes using the quadtree.
-        svg.on("mousedown", function() {
-          var m0 = d3.mouse(this);
-        
-          var rect = d3.select(this).append("rect")
-              .style("fill", "#999")
-              .style("fill-opacity", .5);
-        
-          d3.select(window).on("mousemove", function() {
+        });
+
+        /*     textgroup.attr("transform", function(d) {
+         return "translate(" + d.x + "," + d.y + ")";
+         });*/
+    }
+
+    // Highlight selected nodes using the quadtree.
+    svg.on("mousedown", function () {
+        var m0 = d3.mouse(this);
+
+        var rect = d3.select(this).append("rect")
+                .style("fill", "#999")
+                .style("fill-opacity", .5);
+
+        d3.select(window).on("mousemove", function () {
             var m1 = d3.mouse(rect.node()),
-                x0 = Math.min(w, m0[0], m1[0]),
-                y0 = Math.min(w, m0[1], m1[1]),
-                x1 = Math.max(0, m0[0], m1[0]),
-                y1 = Math.max(0, m0[1], m1[1]);
-                // console.log("DEBUG: mousedown: " + (x1-x0) + ( y1-y0));       
-                    selectNodes(data.nodes, x0, y0, x1, y1);                    
-                    rect.attr("x", x0).attr("y", y0).attr("width", x1 - x0).attr("height", y1 - y0);
-                    
-          });
-        
-          d3.select(window).on("mouseup", function() {
+                    x0 = Math.min(w, m0[0], m1[0]),
+                    y0 = Math.min(w, m0[1], m1[1]),
+                    x1 = Math.max(0, m0[0], m1[0]),
+                    y1 = Math.max(0, m0[1], m1[1]);
+            // console.log("DEBUG: mousedown: " + (x1-x0) + ( y1-y0));       
+            selectNodes(data.nodes, x0, y0, x1, y1);
+            rect.attr("x", x0).attr("y", y0).attr("width", x1 - x0).attr("height", y1 - y0);
+
+        });
+
+        d3.select(window).on("mouseup", function () {
             // only change selection, if the rectangle was big enough 
             // (mainly to prevent clearing of the graph on clicks that look like mousemoves to the system)
